indexing
	description: "External %"C%" random functions for GMP_INTEGER_REFs"
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	GMP_RANDOM_INTEGER_FUNCTIONS

feature -- Access

	mpz_urandomb (rop, a_state: POINTER; n: INTEGER) is
			-- Generate a uniformly distributed random integer in the range 0 to 2 ^ 1n' - 1, inclusive.
		external
			"C (mpz_ptr, __gmp_randstate_struct *, unsigned long int) | %"gmp.h%""
		end

	mpz_urandomm (rop, a_state, n: POINTER) is
			-- Generate a uniform random integer in the range 0 to `n; - 1, inclusive.
		external
			"C (mpz_ptr, __gmp_randstate_struct *, mpz_srcptr) | %"gmp.h%""
		end

	mpz_rrandomb (rop, a_state: POINTER; n: INTEGER) is
			-- Generate a random integer with long strings of zeros and ones in the binary representation.
			-- The random number will be in the range 0 to 2 ^ `n; - 1, inclusive.
		external
			"C (mpz_ptr, __gmp_randstate_struct *, unsigned long int) | %"gmp.h%""
		end

end -- class GMP_RANDOM_INTEGER_FUNCTIONS
