indexing
	description: "Objects that ..."
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	GMP_RANDATA_LC

inherit
	MEMORY_STRUCTURE
		export
			{NONE} all
		redefine
			out
		end

create
	make_by_pointer

feature -- Access

	adder: INTEGER is
			-- Adder
		do
			Result := mp_c (item)
		end

	m2exp: INTEGER is
			-- If /= 0, modulus is 2 ^ `Result'
		do
			Result := mp_m2exp (item)
		end
		
	modulus: GMP_INTEGER_REF is
			-- Modulus (valid only if `m2exp' = 0)
		require
			
		do
			create Result.make_by_pointer (mp_m (item))
		end

	multiplier: GMP_INTEGER_REF is
			-- Multiplier
		do
			create Result.make_by_pointer (mp_a (item))
		end

feature -- Measurement

	structure_size: INTEGER is
			-- Size to allocate (in bytes)
		do
			Result := c_structure_size
		end

feature -- Output

	out: STRING is
			-- Simple string representation
		do
			Result := "[adder: "
			Result.append_string (adder.out)
			Result.append_string (", modulus: ")
			if m2exp /= 0 then
				Result.append_string ((2 ^ m2exp).out)
			else
				Result.append_string (modulus.out)
			end
			Result.append_string (", multiplier: ")
			Result.append_string (multiplier.out)
			Result.append_character (']')
		end

feature {NONE} -- Externals

	c_structure_size: INTEGER is
			-- Size of  "C" struct __gmp_randata_lc.
		external
			"C [macro %"gmp.h%"]"
		alias
			"sizeof (__gmp_randata_lc)"
		end

	mp_a (p: POINTER): POINTER is
		external
			"C [struct %"gmp.h%"] (__gmp_randata_lc): EIF_POINTER"
		alias
			"_mp_a"
		end

	mp_c (p: POINTER): INTEGER is
		external
			"C [struct %"gmp.h%"] (__gmp_randata_lc): EIF_INTEGER"
		alias
			"_mp_c"
		end

	mp_m (p: POINTER): POINTER is
		external
			"C [struct %"gmp.h%"] (__gmp_randata_lc): EIF_POINTER"
		alias
			"_mp_m"
		end

	mp_m2exp (p: POINTER): INTEGER is
		external
			"C [struct %"gmp.h%"] (__gmp_randata_lc): EIF_INTEGER"
		alias
			"_mp_m2exp"
		end

end -- class GMP_RANDATA_LC
