indexing
	description: "Object to comtrol the precision of GMP_REAL_REFs"
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	GMP_DEFAULT_PRECISION

inherit
	GMP_REAL_FUNCTIONS
		export
			{NONE} all
		end

	SINGLETON

create
	default_create

feature -- Access

	default_precision: INTEGER is
			-- Default precision.
		do
			Result := mpf_get_default_prec
		end

feature -- Element change

	set_default_precision (a_precision: INTEGER) is
			-- Set `default_precision' to at least `a_precision' bits.
		require
			a_precision_positive: a_precision > 0
		do
			mpf_set_default_prec (a_precision)
		ensure
			default_precision_set: default_precision >= a_precision
		end

invariant
	default_precision_positive: default_precision > 0

end -- class GMP_DEFAULT_PRECISION
