indexing
	description: "Fibonacci sequence of GMP_INTEGER_REFs"
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	GMP_FIBONACCI

inherit
	COUNTABLE_SEQUENCE [GMP_INTEGER_REF]
		redefine
			changeable_comparison_criterion, default_create
		end

	GMP_INTEGER_MATH
		rename
			remove as gmp_integer_math_remove
		export
			{NONE} all
		redefine
			default_create
		end

create
	default_create

feature {NONE} -- Initialization

	default_create is
			-- Initialize `Current'.
			-- Use `is_equal' to compare objects.
		do
			changeable_comparison_criterion := True
			compare_objects
			changeable_comparison_criterion := False
		end

feature -- Access

	i_th (i: INTEGER): GMP_INTEGER_REF is
			-- The `i'-th item
		do
			create Result
			mpz_fib_ui (Result.item, i)
		end

feature -- Status report

	changeable_comparison_criterion: BOOLEAN
			-- May `object_comparison' be changed?

end -- class GMP_FIBONACCI
