indexing
	description: "Math operations on GMP_RATIONAL_REFs"
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	GMP_RATIONAL_MATH

inherit
	GMP_RATIONAL_FUNCTIONS
		export
			{NONE} all
		end

feature -- Access

	div_2_exp (base: GMP_RATIONAL_REF; exp: INTEGER): GMP_RATIONAL_REF is
			-- `base' divided by 2 ^ `exp'
		require
			base_exists: base /= Void
			exp_not_negative: not (exp < 0)
		do
			create Result
			mpq_div_2exp (Result.item, base.item, exp)
		end

	invert (r: GMP_RATIONAL_REF): GMP_RATIONAL_REF is
			-- Inverse of `r'.
		require
			r_exists: r /= Void
			r_not_zero: not r.is_equal (r.zero)
		do
			create Result
			mpq_inv (Result.item, r.item)
		end

	mul_2_exp (base: GMP_RATIONAL_REF; exp: INTEGER): GMP_RATIONAL_REF is
			-- `base' times 2 ^ `exp'
		require
			base_exists: base /= Void
			exp_not_negative: not (exp < 0)
		do
			create Result
			mpq_mul_2exp (Result.item, base.item, exp)
		end

end -- class GMP_RATIONAL_MATH
