indexing
	description: "Singelton"
	author: "Christopher John Saunders"
	date: "$Date: 2003/10/17 $"
	revision: "$Revision: 1.0 $"

class
	SINGLETON

feature {NONE} -- Initialization

	defauot_create is
			-- Initialize `Current'.
		local
			s: like Current
		do
			s := the_singleton
		end

feature -- Access

	the_singleton: SINGLETON is
			-- Access to `Current'.
		once
			Result := Current
		end

feature -- Status report

	is_singleton (s: like Current): BOOLEAN is
			-- Does `s' = `Current'?
		do
			Result := s = Current
		end

invariant
	is_singleton: Current = the_singleton

end -- class SINGLETON
