indexing
	description	: "System's root class"
	note		: "Initial version automatically generated"

class
	ROOT_CLASS

creation
	make

feature -- Initialization

	make is
			-- Creation procedure.
		do
			create ri.make (I_max)
			ri.start
			create rm.make (100)
			rm.start
			create rq.make (Q_max, Q_max)
			rq.start
			create rr.make (100)
			rr.start

			from
				i := 1
				print ("SOME RANDOM NUMBERS:"); crr
			until
				i > Random_loop_max
			loop
				print (random_integer); cr
				print (random_integer_complex); cr
				print (random_mpfr); cr
				print (random_mpfr_complex); cr
				print (random_rational); cr
				print (random_rational_complex); cr
				print (random_real); cr
				print (random_real_complex); crr
				i := i + 1
			end
			crr; cr
			from
				i := 1
				create fibonacci
				fibonacci.start
				print ("FIBONACCI SEQUENCE:"); crr
			until
				i > Fibonacci_loop_max
			loop
				print (fibonacci.item); cr
				fibonacci.forth
				i := i + 1
			end
			crr; cr
			from
				i := 1
				create lucas
				lucas.start
				print ("LUCAS SEQUENCE:"); crr
			until
				i > Lucas_loop_max
			loop
				print (lucas.item); cr
				lucas.forth
				i := i + 1
			end
			crr; cr
			from
				i := 1
				create primes
				primes.start
				print ("PRIME NUMBER SEQUENCE:"); crr
			until
				i > Prime_loop_max
			loop
				print (primes.item); cr
				primes.forth
				i := i + 1
			end
		end

feature -- Access

	fibonacci: GMP_FIBONACCI
	lucas: GMP_LUCAS
	primes: GMP_PRIMES

	i: INTEGER

	Random_loop_max: INTEGER is 3
	Fibonacci_loop_max: INTEGER is 10
	Lucas_loop_max: INTEGER is 10
	Prime_loop_max: INTEGER is 10

	precision: GMP_DEFAULT_PRECISION
	rational_math: GMP_RATIONAL_MATH
	real_math: GMP_REAL_MATH

feature {NONE} -- Implementation

	cr is
			-- Print a carriage return
		do
			io.put_string ("%N")
		end

	crr is
			-- Print a double carriage return
		do
			io.put_string ("%N%N")
		end

	ri: GMP_RANDOM_INTEGER
	rm: GMP_RANDOM_MPFR
	rq: GMP_RANDOM_RATIONAL
	rr: GMP_RANDOM_REAL

	I_max: GMP_INTEGER_REF is
		once
			create Result.make_from_string ("999999999999999999999999999999")
		end

	Q_max: GMP_INTEGER_REF is
		once
			create Result.make_from_string ("999999999999999")
		end

	random_integer: GMP_INTEGER_REF is
			-- Generate a random GMP_INTEGER_REF
		do
			Result := ri.item
			ri.forth
		end

	random_integer_complex: GMP_INTEGER_COMPLEX_REF is
			-- Generate a random GMP_RATIONAL_COMPLEX_REF
		do
			create Result.make_from_integer_reference (random_integer, random_integer)
		end

	random_mpfr: MPFR_REF is
			-- Generate a random MPFR_REF
		do
			Result := rm.item
			rm.forth
		end

	random_mpfr_complex: MPFR_COMPLEX_REF is
			-- Generate a random MPFR_COMPLEX_REF
		do
			create Result.make_from_mpfr_reference (random_mpfr, random_mpfr)
		end

	random_rational: GMP_RATIONAL_REF is
			-- Generate a random GMP_RATIONAL_REF
		do
			Result := rq.item
			rq.forth
		end

	random_rational_complex: GMP_RATIONAL_COMPLEX_REF is
			-- Generate a random GMP_RATIONAL_COMPLEX_REF
		do
			create Result.make_from_rational_reference (random_rational, random_rational)
		end

	random_real: GMP_REAL_REF is
			-- Generate a random GMP_REAL_REF
		do
			Result := rr.item
			rr.forth
		end

	random_real_complex: GMP_REAL_COMPLEX_REF is
			-- Generate a random GMP_REAL_COMPLEX_REF
		do
			create Result.make_from_real_reference (random_real, random_real)
		end

end -- class ROOT_CLASS
